--------------------------------------------------------------------------------
-- Quicktime Event
-- Tobchen Carnage Contest Weapon
-- Script by Tobchen, July 2010, www.tobchen.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.quicktime={}

-- Load & Prepare Ressources
cc.quicktime.gfx_free = loadgfx("weapons/tobchen_quicktime_free.png")
setmidhandle(cc.quicktime.gfx_free)
cc.quicktime.gfx_up = loadgfx("weapons/tobchen_quicktime_up.png")
setmidhandle(cc.quicktime.gfx_up)
cc.quicktime.gfx_down = loadgfx("weapons/tobchen_quicktime_down.png")
setmidhandle(cc.quicktime.gfx_down)
cc.quicktime.gfx_left = loadgfx("weapons/tobchen_quicktime_left.png")
setmidhandle(cc.quicktime.gfx_left)
cc.quicktime.gfx_right = loadgfx("weapons/tobchen_quicktime_right.png")
setmidhandle(cc.quicktime.gfx_right)

--------------------------------------------------------------------------------
-- Weapon: Quicktime Event
--------------------------------------------------------------------------------

cc.quicktime.id=addweapon("cc.quicktime", "Quicktime Event", cc.quicktime.gfx_free, 0, 2) -- Add Weapon (0 uses, first in round 2)

-- Draw
function cc.quicktime.draw()
	-- Before Event
	if weapon_mode == 0 then
		drawimage(cc.quicktime.gfx_free, getplayerx(0), getplayery(0)-40)
		hudinfo("Press [fire] to start Quicktime Event!")
	elseif weapon_mode < 6 then
		if weapon_success == 0 then
			if weapon_key == 0 then
				drawimage(cc.quicktime.gfx_up, getplayerx(0), getplayery(0)-40)
			elseif weapon_key == 1 then
				drawimage(cc.quicktime.gfx_left, getplayerx(0), getplayery(0)-40)
			elseif weapon_key == 2 then
				drawimage(cc.quicktime.gfx_down, getplayerx(0), getplayery(0)-40)
			elseif weapon_key == 3 then
				drawimage(cc.quicktime.gfx_right, getplayerx(0), getplayery(0)-40)
			end
		else
			drawimage(cc.quicktime.gfx_free, getplayerx(0), getplayery(0)-40)
		end
	end
end

-- Attack
function cc.quicktime.attack(attack)
	if (weapon_shots <= 0 and weapon_mode == 0 and attack == 1) then
		-- No more weapon switching
		useweapon(0)
		weapon_mode = 1
		-- No more player control
		playercontrol(0)
		-- Go
		weapon_shots=weapon_shots+1
		weapon_frame = 0
		math.randomseed(getplayerx(0)*374+getplayery(0)*56+getframe()*123+getround()*98)
		weapon_key = math.random(0, 3)
		weapon_success = 0
		-- Set round time
		changeturntime(10)
	end
	
	if weapon_mode > 0 and weapon_mode < 6 then
		-- Count up
		weapon_frame = weapon_frame + 1
		
		-- Still time left
		if weapon_frame <= 21 then
			if keydown(key_up) == 1 then
				if weapon_key == 0 then
					weapon_success = 1
					weapon_mode = weapon_mode + 1
				end
				weapon_frame = 21
			end
			if keydown(key_left) == 1 then
				if weapon_key == 1 then
					weapon_success = 1
					weapon_mode = weapon_mode + 1
				end
				weapon_frame = 21
			end
			if keydown(key_down) == 1 then
				if weapon_key == 2 then
					weapon_success = 1
					weapon_mode = weapon_mode + 1
				end
				weapon_frame = 21
			end
			if keydown(key_right) == 1 then
				if weapon_key == 3 then
					weapon_success = 1
					weapon_mode = weapon_mode + 1
				end
				weapon_frame = 21
			end
		-- Time up
		else
			if weapon_success == 0 then
				weapon_mode = 7
				
				-- Find teamally with most hp, kill him
				the_table = playertable(1, 0)
				the_player = playercurrent()
				the_health = getplayerhealth(the_player)
				if #the_table > 0 then
					for i=1, #the_table, 1 do
						if getplayerhealth(the_table[i]) > the_health then
							the_health = getplayerhealth(the_table[i])
							the_player = the_table[i]
						end
					end
				end
				playerdamage(the_player, getplayerhealth(the_player))
				
				endturn()
			else
				if weapon_frame > 50 then
					weapon_frame = 0
					weapon_success = 0
					math.randomseed(getplayerx(0)*374+getplayery(0)*56+getframe()*123+getround()*98)
					weapon_key = math.random(0, 3)
				end
			end
		end
		
		-- Scrolling
		scroll(getplayerx(0), getplayery(0))
	end
	
	if weapon_mode == 6 then
		-- Find enemy with most hp, kill him
		the_table = playertable(3, 0)
		if #the_table > 0 then
			the_player = -1
			the_health = 0
			for i=1, #the_table, 1 do
				if getplayerhealth(the_table[i]) > the_health then
					the_health = getplayerhealth(the_table[i])
					the_player = the_table[i]
				end
			end
			playerdamage(the_player, getplayerhealth(the_player))
		end
		
		weapon_mode = 7
		playercontrol(1)
		endturn()
	end
end